## mingw-ocaml 3.12.1+debian2

=== Makefile ===
VERSION = 0.11
all: flexlink.exe support

.PHONY: version.ml
version.ml:
	echo "let version = \"$(VERSION)\"" > version.ml

# Supported tool-chains

CHAINS = mingw cygwin msvc


# Compilers

MSVCC = cl /nologo /MD -D_CRT_SECURE_NO_DEPRECATE
CYGCC = gcc 
MINCC = gcc -mno-cygwin
OCAMLOPT = ocamlopt
#OCAMLOPT = FLEXLINKFLAGS=-real-manifest ocamlopt
#LINKFLAGS = unix.cmxa
LINKFLAGS =

support:
	for i in $(CHAINS); do $(MAKE) build_$$i ; done 

build_msvc: flexdll_msvc.obj flexdll_initer_msvc.obj
build_cygwin: flexdll_cygwin.o flexdll_initer_cygwin.o 
build_mingw: flexdll_mingw.o flexdll_initer_mingw.o 

OBJS = version.ml coff.ml cmdline.ml reloc.ml

flexlink.exe: $(OBJS)
	@echo Building flexlink.exe with TOOLCHAIN=$(TOOLCHAIN)
	rm -f flexlink.exe
	$(OCAMLOPT) -o flexlink.exe $(LINKFLAGS) $(OBJS)

flexdll_msvc.obj: flexdll.h flexdll.c
	$(MSVCC) -c /Fo"flexdll_msvc.obj" flexdll.c

flexdll_cygwin.o: flexdll.h flexdll.c
	$(CYGCC) -c -o flexdll_cygwin.o flexdll.c

flexdll_mingw.o: flexdll.h flexdll.c
	$(MINCC) -c -o flexdll_mingw.o flexdll.c

flexdll_initer_mingw.o: flexdll_initer.c
	$(MINCC) -c -o flexdll_initer_mingw.o flexdll_initer.c

flexdll_initer_cygwin.o: flexdll_initer.c
	$(CYGCC) -c -o flexdll_initer_cygwin.o flexdll_initer.c

flexdll_initer_msvc.obj: flexdll_initer.c
	$(MSVCC) -c /Fo"flexdll_initer_msvc.obj" flexdll_initer.c

demo_msvc: flexlink.exe flexdll_msvc.obj
	(cd test && $(MAKE) clean demo CHAIN=msvc CC="$(MSVCC)" O=obj)

demo_cygwin: flexlink.exe flexdll_cygwin.o
	(cd test && $(MAKE) clean demo CHAIN=cygwin CC="$(CYGCC)" O=o)

demo_mingw: flexlink.exe flexdll_mingw.o
	(cd test && $(MAKE) clean demo CHAIN=mingw CC="$(MINCC)" O=o)

demo_msvc64:  flexlink.exe flexdll_msvc.obj
	(cd test && $(MAKE) clean demo CHAIN=msvc CC="$(MSVCC)" O=obj EXTRA_OPTS="-x64 bufferoverflowu.lib")

clean:
	rm -f *.obj *.o *.lib *.a *.exe *.cmx *.dll *.exp *.cmi *~
	cd test && $(MAKE) clean


## Packaging

COMMON_FILES = LICENSE README CHANGES flexdll.h flexdll.c flexdll_initer.c default.manifest
URL = frisch@frisch.fr:www/flexdll/

# Source packages

PACKAGE = flexdll-$(VERSION).tar.gz

package_src:
	rm -Rf flexdll
	mkdir flexdll
	mkdir flexdll/test
	cp -a *.ml Makefile $(COMMON_FILES) flexdll/
	cp -aR test/Makefile test/*.c flexdll/test/
	tar czf $(PACKAGE) flexdll
	rm -Rf flexdll

upload:
	rsync $(PACKAGE) CHANGES $(URL)

upload_dev:
	$(MAKE) VERSION=dev upload_src

upload_src: package_src upload

# Binary package

PACKAGE_BIN = flexdll-bin-$(VERSION)$(PACKAGE_BIN_SUFFIX).zip

package_bin:
	$(MAKE) clean all
	rm -f $(PACKAGE_BIN)
	zip $(PACKAGE_BIN) $(COMMON_FILES) \
	    flexlink.exe flexdll_*.obj flexdll_*.o

do_upload_bin:
	rsync $(PACKAGE_BIN) $(URL)

upload_bin: package_bin do_upload_bin

upload_bin_64:
	PACKAGE_BIN_SUFFIX=-amd64 $(MAKE) upload_bin

include $(shell cygpath -ad "$(shell ocamlopt -where)/Makefile.config")

show_toolchain:
	@echo Toolchain for the visible ocamlopt: $(TOOLCHAIN)


swap:
	NOMLFICORE=1 $(OCAMLOPT) -o flexlink-new.exe $(LINKFLAGS) $(OBJS)
	cp flexlink.exe flexlink.exe.bak
	cp flexlink-new.exe flexlink.exe

PREFIX = "C:\Program Files\flexdll"

install:
	mkdir -p $(PREFIX)
	cp $(COMMON_FILES) flexlink.exe flexdll_*.obj flexdll_*.o $(PREFIX)

=== debugger/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the Q Public License version 1.0.                #
#                                                                       #
#########################################################################

# $Id: Makefile 8955 2008-07-29 08:31:41Z xleroy $

UNIXDIR=../otherlibs/unix
include Makefile.shared

=== emacs/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1997 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU General Public License.                  #
#                                                                       #
#########################################################################

# $Id: Makefile 10661 2010-08-30 10:16:22Z doligez $

include ../config/Makefile

# Files to install
FILES=	caml-font.el caml-hilit.el caml.el camldebug.el \
	inf-caml.el caml-compat.el caml-help.el caml-types.el \
	caml-xemacs.el caml-emacs.el

# Where to install. If empty, automatically determined.
#EMACSDIR=

# Name of Emacs executable
EMACS=emacs

# Where to install ocamltags script
SCRIPTDIR = $(BINDIR)

# Command for byte-compiling the files
COMPILECMD=(progn \
	      (setq load-path (cons "." load-path)) \
	      (byte-compile-file "caml-xemacs.el") \
	      (byte-compile-file "caml-emacs.el") \
	      (byte-compile-file "caml.el") \
	      (byte-compile-file "inf-caml.el") \
	      (byte-compile-file "caml-help.el") \
	      (byte-compile-file "caml-types.el") \
	      (byte-compile-file "camldebug.el"))

install:
	@if test "$(EMACSDIR)" = ""; then \
	  set xxx `($(EMACS) --batch --eval "(mapcar 'print load-path)") \
	           2>/dev/null | \
	           sed -n -e '/\/site-lisp/s/"//gp'`; \
	  if test "$$2" = ""; then \
	    echo "Cannot determine Emacs site-lisp directory"; \
	    exit 2; \
	  fi; \
	  $(MAKE) EMACSDIR="$$2" simple-install; \
	else \
	  $(MAKE) simple-install; \
	fi

# install the .el files, but do not compile them.
install-el:
	$(MAKE) NOCOMPILE=true install

simple-install:
	@echo "Installing in $(EMACSDIR)..."
	if test -d $(EMACSDIR); then : ; else mkdir -p $(EMACSDIR); fi
	cp $(FILES) $(EMACSDIR)
	if [ -z "$(NOCOMPILE)" ]; then \
	  cd $(EMACSDIR); $(EMACS) --batch --eval '$(COMPILECMD)'; \
	fi

ocamltags:	ocamltags.in
	sed -e 's:@EMACS@:$(EMACS):' ocamltags.in >ocamltags
	chmod a+x ocamltags

install-ocamltags: ocamltags
	cp ocamltags $(SCRIPTDIR)/ocamltags

# This is for testing purposes
compile-only:
	$(EMACS) --batch --eval '$(COMPILECMD)'

clean:
	rm -f ocamltags *~ #*# *.elc

=== tools/extract_args/Makefile ===
all: extract_args

extract_args: extract_args.ml
	ocamlc -o extract_args -custom str.cma extract_args.ml

clean:
	rm -f *.cmo *.cmi *.cma extract_args

=== camlp4/unmaintained/ocamllex/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#                                Camlp4                                 #
#                                                                       #
#   Copyright 2004 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the Q Public License version 1.0.                #
#                                                                       #
#########################################################################
#
# Makefile for pa_ocamllex
# M.Mauny
#

include ../../config/Makefile.cnf

OCAMLTOP=../../..

CAMLP4=../../camlp4/camlp4$(EXE)

OCAMLC=$(OCAMLTOP)/ocamlc$(EXE)
OCAMLOPT=$(OCAMLTOP)/ocamlopt$(EXE)

P4INCLUDES= -nolib -I ../../etc -I ../../meta
OCAMLINCLUDES= -nostdlib -I $(OCAMLTOP)/stdlib -I ../../camlp4 -I ../../lib -I $(OCAMLTOP)/lex
OCAMLCFLAGS=-warn-error A $(OCAMLINCLUDES)

SRC=pa_ocamllex.ml
OBJS=pa_ocamllex.cmo
OBJSX=$(OBJS:.cmo=.cmx)

all: $(OBJS) pa_ocamllex.cma

opt: $(OBJSX) pa_ocamllex.cmxa

pa_ocamllex.cma: pa_ocamllex.cmo
	$(OCAMLC) $(OCAMLCFLAGS) cset.cmo syntax.cmo table.cmo lexgen.cmo compact.cmo pa_ocamllex.cmo -a -o pa_ocamllex.cma

pa_ocamllex.cmxa: pa_ocamllex.cmo
	$(OCAMLOPT) $(OCAMLCFLAGS) cset.cmx syntax.cmx table.cmx lexgen.cmx compact.cmx pa_ocamllex.cmx -a -o pa_ocamllex.cmxa

clean:
	rm -f *.cm* *.$(O) *.$(A) *.bak .*.bak

depend:

.SUFFIXES: .cmx .cmo .cmi .ml .mli

.mli.cmi:
	$(OCAMLC) $(OCAMLCFLAGS) -c $<


.ml.cmo:
	$(OCAMLC) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

.ml.cmx:
	$(OCAMLOPT) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

=== testsuite/interactive/lib-graph-3/Makefile ===
#MODULES=
MAIN_MODULE=sorts
ADD_COMPFLAGS=-thread
LIBRARIES=unix threads graphics

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common

=== testsuite/tests/basic-io-2/Makefile ===
#MODULES=
MAIN_MODULE=io
EXEC_ARGS=io.ml

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common

=== testsuite/tests/lib-bigarray-2/Makefile ===
LIBRARIES=unix bigarray
C_FILES=bigarrfstub
F_FILES=bigarrf

include ../../makefiles/Makefile.several
include ../../makefiles/Makefile.common

=== testsuite/tests/lib-dynlink-bytecode/Makefile ===
default: compile run

compile:
	@for file in stub*.c; do \
	  $(OCAMLC) -c $$file; \
	  $(OCAMLMKLIB) -o `echo $$file | sed -e 's/stub/plug/' | sed -e 's/\.c//'` `basename $$file c`o; \
	done
	@for file in plug*.ml; do \
	  $(OCAMLC) -c $$file; \
	  $(OCAMLMKLIB) -o `basename $$file .ml` `basename $$file ml`cmo; \
	done
	@$(OCAMLC) -c main.ml
	@$(OCAMLC) -o main dynlink.cma main.cmo
	@$(OCAMLC) -o static -linkall plug1.cma plug2.cma -use-runtime $(PREFIX)/bin/ocamlrun
	@$(OCAMLC) -o custom -custom -linkall plug2.cma plug1.cma -I .

run:
	@printf " ... testing 'main'"
	@export LD_LIBRARY_PATH=`pwd` && ./main plug1.cma plug2.cma > main.result
	@diff -q main.reference main.result > /dev/null || (echo " => failed" && exit 1)
	@echo " => passed"

	@printf " ... testing 'static'"
	@export LD_LIBRARY_PATH=`pwd` && ./static > static.result
	@diff -q static.reference static.result > /dev/null || (echo " => failed" && exit 1)
	@echo " => passed"

	@printf " ... testing 'custom'"
	@export LD_LIBRARY_PATH=`pwd` && ./custom > custom.result
	@diff -q custom.reference custom.result > /dev/null || (echo " => failed" && exit 1)
	@echo " => passed"

clean: defaultclean
	@rm -f ./main ./static ./custom *.result

include ../../makefiles/Makefile.common

=== testsuite/tests/lib-num/Makefile ===
MODULES=test test_nats test_big_ints test_ratios test_nums test_io
MAIN_MODULE=end_test
ADD_COMPFLAGS=-w a
LIBRARIES=nums

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common

=== testsuite/tests/tool-ocamldoc/Makefile ===
CUSTOM_MODULE=odoc_test
ADD_COMPFLAGS=-I +ocamldoc

run: $(CUSTOM_MODULE).cmo
	@for file in t*.ml; do \
	  printf " ... testing '$$file'"; \
	  $(OCAMLDOC) -g $(CUSTOM_MODULE).cmo -o `basename $$file ml`result $$file; \
	  diff -q `basename $$file ml`reference `basename $$file ml`result > /dev/null && echo " => passed" || (echo " => failed" && exit 1); \
	done;
	@$(OCAMLDOC) -html t*.ml 2>&1 | grep -v test_types_display || true
	@$(OCAMLDOC) -latex t*.ml 2>&1 | grep -v test_types_display || true


clean: defaultclean
	@rm -f *.result *.html *.tex *.log *.out *.sty *.toc *.css *.aux

include ../../makefiles/Makefile.common

=== testsuite/tests/typing-fstclassmod/Makefile ===
#MODULES=
MAIN_MODULE=fstclassmod
ADD_COMPFLAGS=-w a

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common

=== debian/changelog ===
mingw-ocaml (3.12.1+debian2) unstable; urgency=low

  * Fixed typo in dummy transitional package.. 

 -- Romain Beauxis <toots@rastageeks.org>  Sun, 09 Oct 2011 15:08:07 +0200

mingw-ocaml (3.12.1+debian1) unstable; urgency=low

  * New upstream release.
  * Now using gcc-mingw-w64. Thanks to Török Edwin and Stephen Kitt
    for very good bug report and suggestions!
  Closes: #624533
  * Renamed source package in a non architecture-specific way.
  * Provide prefixed binary directly in /usr/bin
  * Removed camlp4 from the package: produced binaries where not ELF..
  * Added patch to fix socket being turned non-blocking after
    calling select() on them (see upstream #5328).
  * Dropped fix_fd_leak.patch: fix applied upstream.

 -- Romain Beauxis <toots@rastageeks.org>  Sun, 09 Oct 2011 03:51:02 +0200

mingw32-ocaml (3.12.0+debian3) unstable; urgency=low

  * Removed dirty suggestion to override PATH
    to force detection of cross-compiler tools
    in README.Debian
  * Fixed camlp4 META file. 
  * Fixed fd leak in Unix.

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 05 Apr 2011 11:58:57 -0500

mingw32-ocaml (3.12.0+debian2) unstable; urgency=low

  * Upload to unstable.
  * Fixed flexlink path.
  * Switched to gcc-mingw32.

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 04 Apr 2011 11:36:30 -0500

mingw32-ocaml (3.12.0+debian1) experimental; urgency=low

  * Updated package to 3.12.0. 
  * Bumped standards-version to 3.9.1
  * New build and install camlp4.
  * Upload to experimental until new stable release
    and ocaml 3.12.0 in sid.

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 10 Aug 2010 21:55:52 -0500

mingw32-ocaml (3.12.0~beta1+debian1) unstable; urgency=low

  * Updated package to 3.12.0+beta1 

 -- Romain Beauxis <toots@rastageeks.org>  Thu, 24 Jun 2010 01:20:13 +0200

mingw32-ocaml (3.11.2+debian4) unstable; urgency=low

  * Added a patch to hardcode linker's options
    for ocamlmklib.
  * Modified custom Makefile to call the correct ranlib
    and setup correct options for dynlink and shared object
    compilation.
  * Added missing files to install target.
  Thanks to Pierre Letouzey for testing and reporting 
  these issues. 

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 22 Feb 2010 20:24:08 -0600

mingw32-ocaml (3.11.2+debian3) unstable; urgency=low

  * Fixed build-dep for kfreebsd-amd64. 
  * Removed kfreebsd-amd64 from binary archs since
    mingw32 since to not be working on this arch.

 -- Romain Beauxis <toots@rastageeks.org>  Thu, 11 Feb 2010 09:09:02 -0600

mingw32-ocaml (3.11.2+debian2) unstable; urgency=low

  * ocamlrun ABI depends on ocaml version. Hence,
    shipping a local one now. 
  * Added hurd-i386 kfreebsd-amd64 kfreebsd-i386 to 
    the list of target arch.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 10 Feb 2010 17:57:34 -0600

mingw32-ocaml (3.11.2+debian1) unstable; urgency=low

  * Updated to ocaml 3.11.2 
  * Refreshed patches.
  * Bumped standards.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 10 Feb 2010 16:13:05 -0600

mingw32-ocaml (3.11.1+debian2) unstable; urgency=low

  * Added a patch to also remove all binary objects
    in byterun/ to force their recompilation.
  Thanks to Jerome Vouillon for reporting and fixing the issue. 
  * Added a patch to display "Win32" as the os_type when invoking
  ocaml{c,opt} -config

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 27 Jan 2010 14:21:29 -0600

mingw32-ocaml (3.11.1+debian1) unstable; urgency=low

  * Initial release.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 06 Jan 2010 22:13:02 +0100

=== debian/control ===
Source: mingw-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Romain Beauxis <toots@rastageeks.org>
Build-Depends: cdbs, debhelper (>= 7), quilt, mingw-w64, gcc-multilib [amd64 kfreebsd-amd64], 
               ocaml-nox, camlp4, m4
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/mingw32-ocaml.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/mingw32-ocaml.git

Package: mingw-ocaml
Architecture: i386 amd64 kfreebsd-amd64 kfreebsd-i386
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ocaml-nox,
 ocaml-findlib,
 mingw-w64
Description: OCaml cross-compiler based on mingw
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to build OCaml code targeted
 to be executed under windows.

Package: mingw32-ocaml
Architecture: all
Depends: mingw-ocaml, ${misc:Depends}
Description: OCaml cross-compiler based on mingw -- dummy transitional package
 This package is a dummy transitional package and can be removd safely.
